var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g = Object.create((typeof Iterator === "function" ? Iterator : Object).prototype);
    return g.next = verb(0), g["throw"] = verb(1), g["return"] = verb(2), typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
(function (factory) {
    if (typeof module === "object" && typeof module.exports === "object") {
        var v = factory(require, exports);
        if (v !== undefined) module.exports = v;
    }
    else if (typeof define === "function" && define.amd) {
        define(["require", "exports", "like-ar", "best-globals", "sql-tools"], factory);
    }
})(function (require, exports) {
    //import { TableDefinition } from "backend-plus";
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.WebsqlDb = exports.detectedFeatures = void 0;
    //x// <amd-dependency path="../../../node_modules/like-ar/like-ar.d.ts" name="likeAr"/>
    //x// <reference path="../../node_modules/like-ar/like-ar.d.ts" />
    /// <reference path="../node_modules/types.d.ts/modules/myOwn/in-myOwn.d.ts" />
    /// <reference path="../../../lib/in-backend-plus.d.ts" />
    /// <reference path="../../../lib/backend-plus.d.ts" />
    /// <reference path="../../lib/in-backend-plus.d.ts" />
    /// <reference path="../../lib/backend-plus.d.ts" />
    /// <reference path="../lib/in-backend-plus.d.ts" />
    /// <reference path="../lib/backend-plus.d.ts" />
    /// <reference path="lib/in-backend-plus.d.ts" />
    /// <reference path="lib/backend-plus.d.ts" />
    var likeAr = require("like-ar");
    var best_globals_1 = require("best-globals");
    var SqlTools = require("sql-tools");
    exports.detectedFeatures = {
        needToCopyResults: null
    };
    var WebsqlDb = /** @class */ (function () {
        function WebsqlDb(name) {
            this.name = name;
            var version = 1.0;
            var dbName = this.name;
            var dbDisplayName = this.name;
            var dbSize = 2 * 1024 * 1024;
            try {
                this.db = openDatabase(dbName, version, dbDisplayName, dbSize);
                this.wait4detectedFeatures = this.detectFeatures();
            }
            catch (err) {
                console.log(err.message);
                throw err;
            }
        }
        WebsqlDb.prototype.detectFeatures = function () {
            return __awaiter(this, void 0, void 0, function () {
                var detectedFeatures, detectElement, tableDef, err_1;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            detectedFeatures = { needToCopyResults: false };
                            detectElement = { feature: 'need_to_copy_results', value: false };
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, 5, , 7]);
                            tableDef = {
                                name: '_detect',
                                fields: [
                                    { name: 'feature', typeName: 'text' },
                                    { name: 'value', typeName: 'boolean' }
                                ],
                                primaryKey: ['feature']
                            };
                            return [4 /*yield*/, this.registerStructure(tableDef)];
                        case 2:
                            _a.sent();
                            return [4 /*yield*/, this.putOne('_detect', detectElement)];
                        case 3:
                            _a.sent();
                            return [4 /*yield*/, this.getOne('_detect', ['need_to_copy_results'], true)];
                        case 4:
                            _a.sent();
                            return [3 /*break*/, 7];
                        case 5:
                            err_1 = _a.sent();
                            detectElement.value = true;
                            detectedFeatures.needToCopyResults = true;
                            return [4 /*yield*/, this.putOne('_detect', detectElement)];
                        case 6:
                            _a.sent();
                            return [3 /*break*/, 7];
                        case 7: return [2 /*return*/, detectedFeatures];
                    }
                });
            });
        };
        WebsqlDb.prototype.generateSqlForTableDef = function (tableDef) {
            var typeDb = {
                integer: 'integer',
                number: 'real',
                date: 'text',
                boolean: 'text',
                text: 'text',
                jsonb: 'text',
                json: 'text'
            };
            var lines = [];
            var consLines = [];
            lines.push('CREATE TABLE IF NOT EXISTS ' + SqlTools.quoteIdent(tableDef.name) + ' (');
            var fields = [];
            tableDef.fields.forEach(function (fieldDef) {
                var fieldType = typeDb[fieldDef.typeName] || '"' + fieldDef.typeName + '"';
                if (fieldDef.sizeByte == 4) {
                    fieldType = 'integer';
                }
                fields.push('  ' + SqlTools.quoteIdent(fieldDef.name) +
                    ' ' + fieldType +
                    (fieldDef.defaultValue != null ? ' default ' + SqlTools.quoteLiteral(fieldDef.defaultValue) : '') +
                    (fieldDef.defaultDbValue != null ? ' default ' + fieldDef.defaultDbValue : ''));
                if (fieldDef.typeName === 'text' && !fieldDef.allowEmptyText) {
                    consLines.push('alter table ' + SqlTools.quoteIdent(tableDef.name) +
                        ' add constraint ' + SqlTools.quoteIdent(fieldDef.name + "<>''") +
                        ' check (' + SqlTools.quoteIdent(fieldDef.name) + "<>'');");
                }
                if (fieldDef.nullable === false) {
                    consLines.push('alter table ' + SqlTools.quoteIdent(tableDef.name) +
                        ' alter column ' + SqlTools.quoteIdent(fieldDef.name) + ' set not null;');
                }
            });
            lines.push(fields.join(', \n'));
            if (tableDef.primaryKey) {
                lines.push(', primary key (' + tableDef.primaryKey.map(function (name) { return SqlTools.quoteIdent(name); }).join(', ') + ')');
            }
            lines.push(');');
            return lines.join('\n'); //+'\n-- conss\n' + consLines.join('\n')
        };
        WebsqlDb.deleteDatabase = function (name) {
            //TODO
            return Promise.resolve();
        };
        WebsqlDb.prototype.executeQuery = function (sql, params) {
            return __awaiter(this, void 0, void 0, function () {
                var db;
                return __generator(this, function (_a) {
                    db = this.db;
                    return [2 /*return*/, new Promise(function (resolve, reject) {
                            if (!db)
                                return reject('no database.');
                            var result;
                            db.transaction(function (tx) {
                                tx.executeSql(sql, params || [], function (_tx, res) {
                                    result = res.rows;
                                });
                            }, function (err) {
                                reject(err);
                            }, function success() {
                                resolve(result);
                            });
                        })];
                });
            });
        };
        ;
        WebsqlDb.prototype.executeQueries = function (sql, data) {
            return __awaiter(this, void 0, void 0, function () {
                var db;
                return __generator(this, function (_a) {
                    db = this.db;
                    return [2 /*return*/, new Promise(function (resolve, reject) {
                            if (!db)
                                return reject('no database.');
                            db.transaction(function (tx) {
                                return __awaiter(this, void 0, void 0, function () {
                                    return __generator(this, function (_a) {
                                        data.forEach(function (data) {
                                            return __awaiter(this, void 0, void 0, function () {
                                                return __generator(this, function (_a) {
                                                    tx.executeSql(sql, data);
                                                    return [2 /*return*/];
                                                });
                                            });
                                        });
                                        return [2 /*return*/];
                                    });
                                });
                            }, function (tx, err) {
                                reject(err);
                            }, function (tx, res) {
                                resolve();
                            });
                        })];
                });
            });
        };
        ;
        WebsqlDb.prototype.registerStructure = function (tableDef) {
            return __awaiter(this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, this.executeQuery("CREATE TABLE IF NOT EXISTS _structures (name string primary key, def string not null);", [])];
                        case 1:
                            _a.sent();
                            return [4 /*yield*/, this.executeQuery("INSERT OR REPLACE INTO _structures (name, def) values (?, ?);", [tableDef.name, JSON.stringify(tableDef)])];
                        case 2:
                            _a.sent();
                            return [4 /*yield*/, this.executeQuery("DROP TABLE IF EXISTS " + SqlTools.quoteIdent(tableDef.name), [])];
                        case 3:
                            _a.sent();
                            return [4 /*yield*/, this.executeQuery(this.generateSqlForTableDef(tableDef), [])];
                        case 4:
                            _a.sent();
                            return [2 /*return*/];
                    }
                });
            });
        };
        WebsqlDb.prototype.getStructure = function (tableName) {
            return __awaiter(this, void 0, void 0, function () {
                var result;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, this.executeQuery("SELECT * from _structures where name = ?", [tableName])];
                        case 1:
                            result = _a.sent();
                            if (result.length) {
                                return [2 /*return*/, JSON.parse(result.item(0).def)];
                            }
                            else {
                                return [2 /*return*/, undefined];
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        WebsqlDb.prototype.existsStructure = function (tableName) {
            return __awaiter(this, void 0, void 0, function () {
                var tableDef;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, this.getStructure(tableName)];
                        case 1:
                            tableDef = _a.sent();
                            return [2 /*return*/, tableDef ? true : false];
                    }
                });
            });
        };
        WebsqlDb.prototype.convertSQLResultSetRowListToArray = function (rowResultSetList, copyResults) {
            var arr = [];
            for (var i = 0; i < rowResultSetList.length; i++) {
                var result = rowResultSetList.item(i);
                if (copyResults) {
                    result = (0, best_globals_1.changing)(result, {});
                }
                arr.push(result);
            }
            return arr;
        };
        WebsqlDb.prototype.fieldIsNotSupported = function (fieldName, notSupportedFields) {
            var isNotSupported = notSupportedFields.find(function (field) {
                return field.name == fieldName;
            });
            return isNotSupported ? true : false;
        };
        WebsqlDb.prototype.getNotSupportedFields = function (tableDef) {
            var jsonbFields = tableDef.fields.filter(function (field) {
                return field.typeName == 'jsonb' || field.typeName == 'date' || field.typeName == 'timestamp' || field.typeName == 'boolean';
            });
            return jsonbFields;
        };
        WebsqlDb.prototype.convertNotSupportedFields = function (records, notSupportedFields) {
            records.forEach(function (row) {
                if (notSupportedFields) {
                    notSupportedFields.forEach(function (notSupportedField) {
                        var fieldName = notSupportedField.name;
                        row[fieldName] = JSON.parse(row[fieldName]);
                    });
                }
            });
            return records;
        };
        WebsqlDb.prototype.getOneIfExists = function (tableName, key) {
            return __awaiter(this, void 0, void 0, function () {
                var err_2;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            _a.trys.push([0, 2, , 3]);
                            return [4 /*yield*/, this.getOne(tableName, key)];
                        case 1: return [2 /*return*/, _a.sent()];
                        case 2:
                            err_2 = _a.sent();
                            return [2 /*return*/, undefined];
                        case 3: return [2 /*return*/];
                    }
                });
            });
        };
        WebsqlDb.prototype.getOne = function (tableName, key, ignoreDetectFeatures) {
            return __awaiter(this, void 0, void 0, function () {
                var tableDef, jsonbFields, fieldNames, whereExpr, sql, result, detectedFeatures, copyResults, convertedResult;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            ignoreDetectFeatures = ignoreDetectFeatures || false;
                            return [4 /*yield*/, this.getStructure(tableName)];
                        case 1:
                            tableDef = _a.sent();
                            jsonbFields = this.getNotSupportedFields(tableDef);
                            fieldNames = tableDef.primaryKey;
                            whereExpr = [];
                            fieldNames.forEach(function (fieldName, i) {
                                whereExpr.push(fieldName + '=' + SqlTools.quoteLiteral(key[i]));
                            });
                            sql = "SELECT * \n                from " + SqlTools.quoteIdent(tableName) + "\n                where " + whereExpr.join(' and ');
                            return [4 /*yield*/, this.executeQuery(sql, [])];
                        case 2:
                            result = _a.sent();
                            if (!!ignoreDetectFeatures) return [3 /*break*/, 4];
                            return [4 /*yield*/, this.wait4detectedFeatures];
                        case 3:
                            detectedFeatures = _a.sent();
                            _a.label = 4;
                        case 4:
                            copyResults = !ignoreDetectFeatures && detectedFeatures.needToCopyResults;
                            convertedResult = this.convertNotSupportedFields(this.convertSQLResultSetRowListToArray(result, copyResults), jsonbFields);
                            if (convertedResult[0]) {
                                return [2 /*return*/, convertedResult[0]];
                            }
                            else {
                                throw Error('no existe el elemento');
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        WebsqlDb.prototype.getChild = function (tableName, parentKey) {
            return __awaiter(this, void 0, void 0, function () {
                var tableDef, jsonbFields, fieldNames, whereExpr, sql, result, detectedFeatures;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, this.getStructure(tableName)];
                        case 1:
                            tableDef = _a.sent();
                            jsonbFields = this.getNotSupportedFields(tableDef);
                            fieldNames = tableDef.primaryKey;
                            whereExpr = [];
                            parentKey.forEach(function (key, i) {
                                whereExpr.push(fieldNames[i] + '=' + SqlTools.quoteLiteral(key));
                            });
                            sql = "SELECT * from " + SqlTools.quoteIdent(tableName);
                            if (parentKey.length) {
                                sql += " where " + whereExpr.join(' and ');
                            }
                            return [4 /*yield*/, this.executeQuery(sql, [])];
                        case 2:
                            result = _a.sent();
                            return [4 /*yield*/, this.wait4detectedFeatures];
                        case 3:
                            detectedFeatures = _a.sent();
                            return [2 /*return*/, this.convertNotSupportedFields(this.convertSQLResultSetRowListToArray(result, detectedFeatures.needToCopyResults), jsonbFields)];
                    }
                });
            });
        };
        WebsqlDb.prototype.getAll = function (tableName) {
            return __awaiter(this, void 0, void 0, function () {
                var tableDef, jsonbFields, results, detectedFeatures;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, this.getStructure(tableName)];
                        case 1:
                            tableDef = _a.sent();
                            jsonbFields = this.getNotSupportedFields(tableDef);
                            return [4 /*yield*/, this.executeQuery("SELECT * from " + SqlTools.quoteIdent(tableName), [])];
                        case 2:
                            results = _a.sent();
                            return [4 /*yield*/, this.wait4detectedFeatures];
                        case 3:
                            detectedFeatures = _a.sent();
                            return [2 /*return*/, this.convertNotSupportedFields(this.convertSQLResultSetRowListToArray(results, detectedFeatures.needToCopyResults), jsonbFields)];
                    }
                });
            });
        };
        WebsqlDb.prototype.getAllStructures = function () {
            return __awaiter(this, void 0, void 0, function () {
                var results, structures, i;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, this.executeQuery("SELECT * from _structures where name <> '_detect'", [])];
                        case 1:
                            results = _a.sent();
                            structures = [];
                            for (i = 0; i < results.length; i++) {
                                structures.push(JSON.parse(results.item(i).def));
                            }
                            return [2 /*return*/, structures];
                    }
                });
            });
        };
        WebsqlDb.prototype.isEmpty = function (tableName) {
            return __awaiter(this, void 0, void 0, function () {
                var result;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, this.executeQuery("SELECT count(*) as cantidad from " + SqlTools.quoteIdent(tableName), [])];
                        case 1:
                            result = _a.sent();
                            return [2 /*return*/, result.item(0).cantidad == 0];
                    }
                });
            });
        };
        WebsqlDb.prototype.putOne = function (tableName, element) {
            return __awaiter(this, void 0, void 0, function () {
                var ldb, createPromiseForFK, tableDef, jsonbFields, promisesArray;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            ldb = this;
                            createPromiseForFK = function createPromiseForFK(fk) {
                                return Promise.resolve().then(function () {
                                    return __awaiter(this, void 0, void 0, function () {
                                        var fkTableDef, pk, isFKCompleteInSource, fkRecord;
                                        return __generator(this, function (_a) {
                                            switch (_a.label) {
                                                case 0: return [4 /*yield*/, ldb.getStructure(fk.references)];
                                                case 1:
                                                    fkTableDef = _a.sent();
                                                    if (!fkTableDef) return [3 /*break*/, 3];
                                                    pk = [];
                                                    fk.fields.forEach(function (field) {
                                                        pk.push(element[field.source]);
                                                    });
                                                    isFKCompleteInSource = fk.fields.filter(function (field) {
                                                        return element[field.source] == null;
                                                    }).length == 0;
                                                    if (!isFKCompleteInSource) return [3 /*break*/, 3];
                                                    return [4 /*yield*/, ldb.getOneIfExists(fk.references, pk)];
                                                case 2:
                                                    fkRecord = _a.sent();
                                                    if (fkRecord) {
                                                        fk.displayFields.forEach(function (field) {
                                                            element[fk.alias + '__' + field] = fkRecord[field];
                                                        });
                                                    }
                                                    _a.label = 3;
                                                case 3: return [2 /*return*/];
                                            }
                                        });
                                    });
                                });
                            };
                            return [4 /*yield*/, ldb.getStructure(tableName)];
                        case 1:
                            tableDef = _a.sent();
                            jsonbFields = this.getNotSupportedFields(tableDef);
                            promisesArray = [];
                            if (tableDef.foreignKeys) {
                                tableDef.foreignKeys.forEach(function (fk) {
                                    return __awaiter(this, void 0, void 0, function () {
                                        return __generator(this, function (_a) {
                                            promisesArray.push(createPromiseForFK(fk));
                                            return [2 /*return*/];
                                        });
                                    });
                                });
                            }
                            if (tableDef.softForeignKeys) {
                                tableDef.softForeignKeys.forEach(function (fk) {
                                    return __awaiter(this, void 0, void 0, function () {
                                        return __generator(this, function (_a) {
                                            promisesArray.push(createPromiseForFK(fk));
                                            return [2 /*return*/];
                                        });
                                    });
                                });
                            }
                            return [4 /*yield*/, Promise.all(promisesArray).then(function () {
                                    return __awaiter(this, void 0, void 0, function () {
                                        var fieldNames, fieldValues, unquotedFieldValues;
                                        return __generator(this, function (_a) {
                                            switch (_a.label) {
                                                case 0:
                                                    fieldNames = [];
                                                    fieldValues = [];
                                                    unquotedFieldValues = [];
                                                    likeAr(element).forEach(function (value, key) {
                                                        fieldNames.push(SqlTools.quoteIdent(key));
                                                        fieldValues.push(SqlTools.quoteLiteral(ldb.fieldIsNotSupported(key, jsonbFields) ? JSON.stringify(value) : value));
                                                        unquotedFieldValues.push(value);
                                                    });
                                                    return [4 /*yield*/, ldb.executeQuery("INSERT OR REPLACE INTO " + SqlTools.quoteIdent(tableName) +
                                                            " (" + fieldNames.join(',') + ") values (" + fieldValues.join(',') + ");", [])];
                                                case 1:
                                                    _a.sent();
                                                    return [2 /*return*/, element];
                                            }
                                        });
                                    });
                                })];
                        case 2: return [2 /*return*/, _a.sent()];
                    }
                });
            });
        };
        WebsqlDb.prototype.putMany = function (tableName, elements) {
            return __awaiter(this, void 0, void 0, function () {
                var sql, ldb, data, tableDef, jsonbFields;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            ldb = this;
                            data = [];
                            return [4 /*yield*/, this.getStructure(tableName)];
                        case 1:
                            tableDef = _a.sent();
                            jsonbFields = this.getNotSupportedFields(tableDef);
                            elements.forEach(function (element) {
                                if (!sql) {
                                    var fieldNames = [];
                                }
                                var values = [];
                                likeAr(element).forEach(function (value, key) {
                                    if (!sql) {
                                        fieldNames.push(SqlTools.quoteIdent(key));
                                    }
                                    values.push(ldb.fieldIsNotSupported(key, jsonbFields) ? JSON.stringify(value) : value);
                                });
                                if (!sql) {
                                    sql = "INSERT OR REPLACE INTO " + SqlTools.quoteIdent(tableName) +
                                        " (" + fieldNames.join(',') + ") values (" + values.map(function (_) { return '?'; }).join(',') + ");";
                                }
                                data.push(values);
                            });
                            return [4 /*yield*/, this.executeQueries(sql, data)];
                        case 2:
                            _a.sent();
                            return [2 /*return*/];
                    }
                });
            });
        };
        WebsqlDb.prototype.close = function () {
            return __awaiter(this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    //TODO
                    return [2 /*return*/, Promise.resolve()];
                });
            });
        };
        WebsqlDb.prototype.clear = function (tableName) {
            return __awaiter(this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, this.executeQuery("DELETE FROM " + SqlTools.quoteIdent(tableName) + ";", [])];
                        case 1:
                            _a.sent();
                            return [2 /*return*/];
                    }
                });
            });
        };
        return WebsqlDb;
    }());
    exports.WebsqlDb = WebsqlDb;
});
//# sourceMappingURL=my-websqldb.js.map